﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;

namespace MvvmLightTest
{
    public class MyViewModel : ViewModelBase
    {
        private Random _random;

        private int _number;

        private bool _isActive;

        public MyViewModel()
        {
            _random = new Random();
        }

        public int Number
        {
            get { return _number; }
            set
            {
                _number = value;                
                RaisePropertyChanged("Number");
            }
        }

        public bool IsActive
        {
            get { return _isActive; }
            set
            {
                _isActive = value;
                RaisePropertyChanged("IsActive");
            }
        }

        private ICommand _setRandomNumberCommand;

        public ICommand SetRandomNumberCommand
        {
            get
            {
                if (_setRandomNumberCommand == null)
                    _setRandomNumberCommand = new RelayCommand(() => SetRandomNumber(), () => IsActive);
                return _setRandomNumberCommand;
            }
        }      

        public void SetRandomNumber()
        {
            Number = _random.Next();
        }

        private ICommand _addNumberCommand;

        public ICommand AddNumberCommand
        {
            get
            {
                if (_addNumberCommand == null)
                    _addNumberCommand = new RelayCommand<int>(i => AddNumber(i));
                return _addNumberCommand;
            }
        }

        public void AddNumber(int n)
        {
            Number += n;
        }
    }
}
